; Make JPEGS out of images reconstructed on Bruker

pro MakeJPEGS

	dirIndex = [4,5,6,7,8,9,10,11]	; image directories
	nIndex = size(dirIndex)		; get size of index array
	print, nIndex
	nScans = nIndex[1]	; # of directories to search through

	recoImages = fltarr(nScans,256,256)
	directory = ''
	; done with intializations so prompt user for image directory
	READ, directory, PROMPT=$
	'Enter parent directory under which your raw data is stored: '

	directory = directory + '/'
	close, /ALL

	; NO CHANGES NEEDED
	for loopNum = 0,nScans - 1 do begin
		;strtrim,2 removes leading + trailing blanks
		scanNumString = strtrim(string(dirIndex(loopNum)),2)
		filename = directory+scanNumString+'/pdata/1/2dseq'
		matrixSize = FindMatrixSize(directory, scanNumString) ; get size of image
		nFreqEncode = matrixSize[0]/2
		nPhaseEncode = matrixSize[1]
		nImages = FindNumberImages(directory, scanNumString)  ; # images per scan
		dcOffset = FindDCOffset(directory, scanNumString)	  ; DC offset/image
		mapSlope = FindRecoMapSlope(directory, scanNumString)
		mapOffset = FindRecoMapOffset(directory, scanNumString)
		recoImages[loopNum,*,*] = ProcessReco(filename, matrixSize, mapOffset, mapSlope)

		print, directory+scanNumString
		close,1
		openw,1,directory+scanNumString+image_
		writeu,1,'image_'+scanNumString
		;close,1
		;openw,1,dataPath+'\DWI_B_'+strtrim(string(Bval_index+1),1)+'_Matrix_Masked_'+directions[dir]
		;writeu,1,DWI_B_matrix_masked

		image_jpeg = bytscl(recoImages[loopNum,*,*])
		WRITE_JPEG,directory+scanNumString+'image_'+scanNumString+'.jpeg',image_jpeg
		;now determine the average signal intensity (log value) of the center and
		;left corner of the image.
		;imageStats is an array of values holding the following statisitcs:
		;[centerMean, cornerMean, centerVar, cornerVar, centerSdv, cornerSdv]
		imageStats = ImageSegment(recoImages[loopNum,*,*],nFreqEncode, nPhaseEncode, boxWidth, boxHeight)
		centerMean[loopNum] = imageStats[0]
		cornerMean[loopNum] = imageStats[1]
		centerVar[loopNum] = imageStats[2]
		cornerVar[loopNum] = imageStats[3]
		centerSdv[loopNum] = imageStats[4]
		cornerSdv[loopNum] = imageStats[5]
	endfor


end
