;Pallavi Rane
;
; DGB 11/24/04
; CHS 11/24/04 Modified to give one path for all files
pro dicomView
	rotate180 = 2
	path = 'C:\Documents and Settings\pallavir\Desktop\MRI_proj\'
	dicomImage1 = READ_DICOM(path+'T1TR400_IM1')
	dicomImage2 = READ_DICOM(path+'T1TR800_IM1')
	dicomImage3 = READ_DICOM(path+'T1TR1600_IM1')
	dicomImage4 = READ_DICOM(path+'T1TR6000_IM1')

	dicomImage5 = READ_DICOM(path+'T2TE50_IM1')
	dicomImage6 = READ_DICOM(path+'T2TE100_IM1')
	dicomImage7 = READ_DICOM(path+'T2TE150_IM1')
	dicomImage8 = READ_DICOM(path+'T2TE200_IM1')

T2 = fltarr(256,256);
T1 = fltarr(256,256);
M0 = fltarr(256,256);
MASK = fltarr(256,256);


	; to view the dimensions of the image;
	; REMEMBER!!! IDL uses (column, row) format!
	; the first element that 'size' prints out is the number of dimensions
	; in the array. The next two elements (if there are 2 dimensions) are
	; # of columns and # of rows in the array respectively.
	print, size(dicomImage8)

	; now view the images using live_image
	; you can left-click on the image to see pixel values
;	live_image, rotate(dicomImage1,rotate180)
;	live_image, rotate(dicomImage2,rotate180)
;	live_image, rotate(dicomImage3,rotate180)
;	live_image, rotate(dicomImage4,rotate180)

;	live_image, rotate(dicomImage5,rotate180)
;	live_image, rotate(dicomImage6,rotate180)
;	live_image, rotate(dicomImage7,rotate180)
;	live_image, rotate(dicomImage8,rotate180)



;T2 map


	;Creating mask all values below 28 from image5 (T2 image with TE = 50)
	FOR i=0,255 DO BEGIN
		FOR j=0,255 DO BEGIN
		IF dicomImage5(i,j) LT 28 THEN Begin
		 MASK(i,j)=0
		ENDIF Else Begin
		 MASK(i,j)=1;
		ENDELSE
		ENDFOR
	ENDFOR
		;For a MASK point if more than 5 points aroung the point values around it are zero, then that point should also be zero
	FOR i=1,254 DO BEGIN
		FOR j=1,254 DO BEGIN
		n=0;
		IF MASK(i-1,j-1) EQ 0 THEN n=n+1;
		IF MASK(i,j-1) EQ 0 THEN n=n+1;
		IF MASK(i+1,j-1) EQ 0 THEN n=n+1;
		IF MASK(i-1,j) EQ 0 THEN n=n+1;
		IF MASK(i+1,j) EQ 0 THEN n=n+1;
		IF MASK(i-1,j+1) EQ 0 THEN n=n+1;
		IF MASK(i,j+1) EQ 0 THEN n=n+1;
		IF MASK(i+1,j+1) EQ 0 THEN n=n+1;

		IF n GT 5 THEN MASK(i,j)=0;

		ENDFOR
	ENDFOR
	;live_image, rotate(mask,rotate180), TITLE = "Mask for T2 images"

	;Multiplying all images with the MASK

	dicomImage5 = dicomImage5*MASK;
	dicomImage6 = dicomImage6*MASK;
	dicomImage7 = dicomImage7*MASK;
	dicomImage8 = dicomImage8*MASK;


TEarr = [50,100,150,200]
T2arr = FLTARR(4)

	FOR i=0,255 DO BEGIN
		FOR j=0,255 DO BEGIN
		IF dicomImage5(i,j) EQ 0 THEN T2(i,j)=0 ELSE BEGIN
			T2arr[0] = ALOG(dicomImage5(i,j))
			T2arr[1] = ALOG(dicomImage6(i,j))
			T2arr[2] = ALOG(dicomImage7(i,j))
			T2arr[3] = ALOG(dicomImage8(i,j))
			T2result = LINFIT(TEarr,T2arr)		;Line fit for TE values on X axis and Ln(Mxy) on Y axis
			x = CORRELATE(TEarr,T2arr)
			IF ABS(x) GT 0.92 THEN BEGIN		;Correlation coefficient of the line fit should be > 0.92
				T2(i,j) = -(1/(T2result(1)))	; T2 = - (1/SLOPE)
			ENDIF ELSE BEGIN
				T2(i,j) = 0
			ENDELSE
		ENDELSE

		IF T2(i,j) GT 250 THEN BEGIN
			T2(i,j)=250; 						;T2 values GT 300 were masked down to 300
		ENDIF

		ENDFOR
	ENDFOR

	Live_image, rotate(T2,rotate180),TITLE = "T2 Map"
;==============================================================


;T1 and M0'  map
	;Creating mask all values below 40 from image4 (T1 image with TR = 6000)
	MASKt1 = fltarr(256,256);
	FOR i=0,255 DO BEGIN
		FOR j=0,255 DO BEGIN
			IF dicomImage4(i,j) LT 40 THEN Begin
		 		MASKt1(i,j)=0
			ENDIF Else Begin
		 		MASKt1(i,j)=1;
			ENDELSE
		ENDFOR
	ENDFOR
	;For a MASKt1 point if more than 5 points aroung the point values around it are zero,
	;then that point should also be zero
	FOR i=1,254 DO BEGIN
		FOR j=1,254 DO BEGIN
			n=0;
			IF MASKt1(i-1,j-1) EQ 0 THEN n=n+1;
			IF MASKt1(i,j-1) EQ 0 THEN n=n+1;
			IF MASKt1(i+1,j-1) EQ 0 THEN n=n+1;
			IF MASKt1(i-1,j) EQ 0 THEN n=n+1;
			IF MASKt1(i+1,j) EQ 0 THEN n=n+1;
			IF MASKt1(i-1,j+1) EQ 0 THEN n=n+1;
			IF MASKt1(i,j+1) EQ 0 THEN n=n+1;
			IF MASKt1(i+1,j+1) EQ 0 THEN n=n+1;

		IF n GT 5 THEN MASKt1(i,j)=0;

		ENDFOR
	ENDFOR
	;live_image, MASKt1, TITLE = "Mask for T1 images"

	;Multiplying all images with the MASK

	dicomImage1 = dicomImage1*MASKt1;
	dicomImage2 = dicomImage2*MASKt1;
	dicomImage3 = dicomImage3*MASKt1;
	dicomImage4 = dicomImage4*MASKt1;

TRarr = [400,800,1600]							; Array of TR values
T1arr = FLTARR(3)
M0temp = FLTARR(256,256)

	n=0;
	FOR i=0,255 DO BEGIN
		FOR j=0,255 DO BEGIN
		IF dicomImage5(i,j) EQ 0 THEN T1(i,j)=0 ELSE BEGIN
			;to take LN(M0' - Mz) M0' should be > Mz
			IF dicomImage4(i,j) GT dicomImage1(i,j) THEN BEGIN
			 T1arr[0] = ALOG(dicomImage4(i,j) - dicomImage1(i,j));
			ENDIF ELSE BEGIN
			 T1arr[0] = 0;
			ENDELSE
			IF dicomImage4(i,j) GT dicomImage2(i,j) THEN BEGIN
			T1arr[1] = ALOG(dicomImage4(i,j) - dicomImage2(i,j));
			ENDIF ELSE BEGIN
			 T1arr[1] = 0;
			ENDELSE
			IF dicomImage4(i,j) GT dicomImage3(i,j) THEN BEGIN
			T1arr[2] = ALOG(dicomImage4(i,j) - dicomImage3(i,j));
			ENDIF ELSE BEGIN
			 T1arr[2] = 0;
			ENDELSE


			T1result = LINFIT(TRarr,T1arr)	;Line fit for TE values on X axis and Ln(Mxy) on Y axis

			x = CORRELATE(TRarr,T1arr)
			IF ABS(x) GT 0.95 THEN BEGIN	;Correlation coefficient of the line fit should be > 0.95
				T1(i,j) = -(1/(T1result(1))); T1 = - (1/SLOPE)
			ENDIF ELSE BEGIN
				T1(i,j) = 0
			ENDELSE
			M0temp(i,j) = EXP(T1result(0))	;M0temp = EXP(Y-intercept)
		ENDELSE

		IF T1(i,j) GT 2500 THEN T1(i,j)=2500;T1 values GT 2500 were masked down to 2500
		IF T1(i,j) LT 200 THEN T1(i,j)= 200	;and values LT 200 were scaled to 200

		IF M0temp(i,j) GT 1500 THEN M0temp(i,j) = 1500	;M0temp values GT 1500 were masked down to 1500
		IF M0temp(i,j) LT 0 THEN M0temp(i,j) = 0		;and values LT 0 were scaled to 0


		ENDFOR
	ENDFOR
	Live_image, rotate(T1,rotate180),TITLE = "T1 Map"
	Live_image, rotate(M0temp,rotate180), TITLE = "M0'"
;==============================================================

;real M0 Map
;For the T1 data sets TE was 20msec

	FOR i=0,255 DO BEGIN
		FOR j=0,255 DO BEGIN
			M0(i,j) = M0temp(i,j)/EXP(-20/T2(i,j));
		ENDFOR
	ENDFOR

	Live_image, rotate(M0,rotate180),TITLE = "Real M0 Map"


;=============================================================


;Simulated Images

Mz = FLTARR(256,256);
	;For TR = 1000mSec and TE = 20mSec
	TR = 1000;
	TE = 20;
	FOR i=0,255 DO BEGIN
		FOR j=0,255 DO BEGIN
			IF T2(i,j) NE 0 AND T1(i,j) NE 0 THEN BEGIN ;To avoid dividing by 0s
				Mz(i,j) = M0(i,j)*EXP(-TE/T2(i,j))*(1-EXP(-TR/T1(i,j)));
				IF Mz(i,j) GT 600 THEN Mz(i,j) = 600
			ENDIF ELSE BEGIN
				Mz(i,j) = 0;
			ENDELSE
		ENDFOR
	ENDFOR

	Live_image, rotate(Mz,rotate180),TITLE = "Simulation : TR = 1000mSec, TE = 20mSec"

Mz = FLTARR(256,256);
	;For TR = 4000mSec and TE = 80mSec
	TR = 4000;
	TE = 80;
	FOR i=0,255 DO BEGIN
		FOR j=0,255 DO BEGIN
			IF T2(i,j) NE 0 AND T1(i,j) NE 0 THEN BEGIN ;To avoid dividing by 0s
				Mz(i,j) = M0(i,j)*EXP(-TE/T2(i,j))*(1-EXP(-TR/T1(i,j)));
				IF Mz(i,j) GT 600 THEN Mz(i,j) = 600
			ENDIF ELSE BEGIN
				Mz(i,j) = 0;
			ENDELSE
		ENDFOR
	ENDFOR

	Live_image, rotate(Mz,rotate180),TITLE = "Simulation : TR = 4000mSec, TE = 80mSec"


end
