; I changed this from Mike's original code whose name was
; image_mean.pro.  The order of the original printing can
; be seen in that code, but I have modified it to only print
; out the mean, median and standard deviation.
;
; To run this you have to change "ext" to t2, adc_map, or enhance for
; the statistics for the T2, ADC or R maps.  In addition, the histogram
; min and max have to be modified for each parameter map.  T2 values
; range from , ADC values need to be multiplied by 10^7, and RTO values
; range from 0 to 30.
;
pro image_mean_kgh
	image=fltarr(64,64)
	id=[2,3,4,5,6,7,8,10,11,12,13,14,15,17,18]
	last_no=[10,6,11,4,11,6,11,12,5,5,1,1,1,1,1]
	openw,2,'C:\papers\Mike\RTOvsADC\Mean_Median_ADC.txt'
	printf,2,'          ID#        Mean         Median        Stddev       SEM     num_pixel';max,max at,lower,upper,width,intrgral,
	for id_loop=0,14 do begin
		text=''
		text1=''
		text2=''
		directory_name='E:\CHEMOTHERAPY\N'+strtrim(string(id(id_loop)),2)+'\NEW\'
		image_name='day'
		ext='_adc_map'
		filename=directory_name+image_name+strtrim(string(last_no(id_loop)),2)+ext
		print,filename
		openr,1,filename
		readu,1,image
		close,1
		byteorder,image,/LSWAP
		image=image
		;live_image,image
		pixel_count=0
		;---------------------------------
		; How many pixel are not equal 0
		;---------------------------------
		for i=0,63 do begin
			for k=0,63 do begin
				if (image(i,k) NE 0.0) then pixel_count=pixel_count+1
			endfor
		endfor
		print,pixel_count
		new_array=fltarr(pixel_count)
		counter=0
		for i=0,63 do begin
			for k=0,63 do begin
				if (image(i,k) NE 0.0) then begin
					new_array(counter)=image(i,k)*10000000
					counter=counter+1
				endif
			endfor
		endfor
		;print, new_array
		result1=mean(new_array)
		result2=median(new_array)
		result=histogram(new_array,binsize=1,min=0,max=250)
		result3 = stddev(new_array)
		;print, result ; this prints out the histogram
		;----------------------------------
		; extract width at half maximum
		;----------------------------------
		maxV=0.0
		bin_number=0
		for x=0,N_ELEMENTS(result)-1 do begin
			if (result(x) GT maxV) then begin
					maxV=result(x)
					bin_number=x
			endif
		endfor
		print, maxV, bin_number
		;-------------------------------
		; find lower half
		;-------------------------------
		lower=bin_number
		repeat begin
			lower=lower-1
		endrep until (result(lower) LT maxV/2.0)
		;-----------------------------
		; FIND UPPER HALF
		;-----------------------------
		upper=bin_number
		repeat begin
			upper=upper+1
		endrep until (result(upper) LT maxV/2.0)
		integral=0.0
		for int_loop=lower,upper do begin
			integral=integral+result(int_loop)
		endfor
		printf,2,'id: '+string(id(id_loop))+' '+string(result1)+' '+string(result2)+' '+ string(result3) + string(result3/(sqrt(pixel_count))) + string(pixel_count)
		;text1=strtrim(string(id(id_loop)),2)+','+strtrim(string(result1),2)+','+strtrim(string(result2),2)
		;text2=text1+','+strtrim(string(maxV),2)+','+strtrim(string(bin_number),2)+','+strtrim(string(lower),2)+','+$
			;strtrim(string(upper),2)+','+strtrim(string((upper-lower)-1),2)+','+strtrim(string(integral),2)
		;print,text2
	endfor
	close,2
end