;  --------------------------------------------------------------------------------------
;  This code allows the calculation of the SNR for raw images or maps.  Each image or map is
;  read in and 2x2 ROI's are selected.  The ROI size is hardwired in the initial values section.  The ROI
;  mean, standard deviation and the pixel coordinate values are all stored.  This calculation
;  of SNR uses the fact that the images are magnitude calculated already.  There is the
;  option to print the data into a file at the end (at the moment this is not implemented).
;  written by KGH 7/7/98 (a modification of roidiff)
;  --------------------------------------------------------------------------------------
pro kghsnr3
;
arraytype=0
arrayname=''
arrayname1=''
def_dir=''
num_sig_roi=1
num_noise_roi=1
sd = 0.0
sdsum = 0.0
meansd = 0.0
;
; read input dialog boxes and widgets
;
def_dir='N:\kgh_data
arrayname = dialog_pickfile(/read,path=def_dir,get_path=arrayname1)    ;pick the file
desc=['0, LABEL, INPUT MENU, CENTER',$
		  '1, BASE,,ROW',$
		  '1, BASE,,COLUMN, FRAME',$
		  '2, BUTTON, BYTE|INTEGER|LONG|FLOAT|COMPLEX, EXCLUSIVE, SET_VALUE=3, LABEL_TOP=INPUT FORMAT :, CENTER , COLUMN, TAG=im_type',$
		  '1, BASE,,COLUMN, FRAME',$
		  '0, LABEL, SIZE :, CENTER',$
		  '0, INTEGER,64, LABEL_LEFT=X-Size :, WIDTH=4, TAG=xsize',$
		  '0, INTEGER,64, LABEL_LEFT=Y-Size :, WIDTH=4, TAG=ysize',$
		  '0, INTEGER,1 , LABEL_LEFT=Z-Size :, WIDTH=4, TAG=zsize',$
		  '0, INTEGER,0,  LABEL_LEFT=Offset :, WIDTH=6, TAG=offset',$
		  '2, INTEGER,1,  LABEL_LEFT=Slices :, WIDTH=4, TAG=slices',$
		  '1, BASE,,COLUMN, FRAME',$
		  '2, BUTTON, YES|NO, EXCLUSIVE, SET_VALUE=0, LABEL_TOP=SWAP :, CENTER, TAG=swap',$
		  '2, BASE,, ROW',$
		  '1, BASE,, ROW',$
		  '0, BUTTON, OK, QUIT, TAG=ok',$
          '2, BUTTON, Cancel, QUIT,TAG=quit']
wid=CW_FORM(desc, /COLUMN, TITLE='Input Format')
case wid.im_type of
0:  a=bytarr(wid.xsize,wid.ysize)
1:  a=intarr(wid.xsize,wid.ysize)
2:  a=lonarr(wid.xsize,wid.ysize)
3:  a=fltarr(wid.xsize,wid.ysize)
4:  a=complexarr(wid.xsize,wid.ysize)
else: stop
endcase
openr,1,arrayname
readu,1,a
close,1
if wid.swap EQ 0 then  begin       ;'yes' is the first choice so = 0
 byteorder,a, /lswap
endif
c=rebin(a,256,256)
;
; pick the signal roi(s)
;
desc1=['0, LABEL, Signal ROI, CENTER',$
		  '1, BASE,,ROW',$
		  '1, BASE,,COLUMN, FRAME',$
		  '2, BUTTON, 1|2|3|4|5, EXCLUSIVE, SET_VALUE=2, LABEL_TOP=# of Signal ROIs :, CENTER , COLUMN, TAG=num_sig_roi',$
		  '2, BASE,, ROW',$
		  '1, BASE,,COLUMN, FRAME',$
		  '2, BUTTON, 1|2|3|4|5, EXCLUSIVE, SET_VALUE=2, LABEL_TOP=ROI Size :, CENTER , COLUMN, TAG=sig_roi_side',$
		  '1, BASE,, ROW',$
		  '0, BUTTON, OK, QUIT, TAG=ok',$
          '2, BUTTON, Cancel, QUIT,TAG=quit']
wid1=CW_FORM(desc1, /COLUMN, TITLE='# of Signal ROIs')
case wid1.num_sig_roi of
 0: num_sig_roi = 1
 1: num_sig_roi = 2
 2: num_sig_roi = 3
 3: num_sig_roi = 4
 4: num_sig_roi = 5
else: stop
endcase
case wid1.sig_roi_side of
 0: sig_roi_side = 1
 1: sig_roi_side = 2
 2: sig_roi_side = 3
 3: sig_roi_side = 4
 4: sig_roi_side = 5
else: stop
endcase
sresult=fltarr(5,num_sig_roi)
snr = fltarr(num_sig_roi)
sumtemp = fltarr(sig_roi_side,sig_roi_side)
window,0,retain=2
tvscl,c
;print the box so the user can decide if it is okay
plots, [0, 255], [255, 255], /device
plots, [255, 255], [255, 0], /device
;
print,'pick the positions for the signal roi'
;
; loop around and wait for the ROI's to get picked
;
for j=0,num_sig_roi-1 do begin
print,j
cursor,x,y,1,/device
wait,2.0
print,x/4,y/4
;
; result holds the data, 0,1=x and y, 2=roi mean,3=standard deviation,4=the pixel value
;
sresult(0,j) = x/4
sresult(1,j) = y/4
;
; read the images values into an array for further processing
;
for k=0,sig_roi_side-1 do begin
 for i=0, sig_roi_side-1 do begin
 sumtemp(i,k) = a(x/4+i,y/4+k)
 endfor
endfor
print, sumtemp
stemp = moment(sumtemp,sdev=sd_s)
sresult(2,j) = stemp(0)  ;mean
sresult(3,j) = sd_s
sresult(4,j) = a(x/4,y/4)  ;pixel value - I don't do anything with this at the moment
endfor
sresult = float(sresult)
;
; pick the noise roi(s)
;
desc2=['0, LABEL, Noise ROI, CENTER',$
		  '1, BASE,,ROW',$
		  '1, BASE,,COLUMN, FRAME',$
		  '2, BUTTON, 1|2|3|4|5, EXCLUSIVE, SET_VALUE=2, LABEL_TOP=# of Noise ROIs :, CENTER , COLUMN, TAG=num_noise_roi',$
		  '2, BASE,, ROW',$
		  '1, BASE,,COLUMN, FRAME',$
		  '2, BUTTON, 1|2|3|4|5, EXCLUSIVE, SET_VALUE=2, LABEL_TOP=ROI Size :, CENTER , COLUMN, TAG=noise_roi_side',$
		  '1, BASE,, ROW',$
		  '0, BUTTON, OK, QUIT, TAG=ok',$
          '2, BUTTON, Cancel, QUIT,TAG=quit']
wid2=CW_FORM(desc2, /COLUMN, TITLE='# of Noise ROIs')
case wid2.num_noise_roi of
 0: num_noise_roi = 1
 1: num_noise_roi = 2
 2: num_noise_roi = 3
 3: num_noise_roi = 4
 4: num_noise_roi = 5
else: stop
endcase
case wid2.noise_roi_side of
 0: noise_roi_side = 1
 1: noise_roi_side = 2
 2: noise_roi_side = 3
 3: noise_roi_side = 4
 4: noise_roi_side = 5
else: stop
endcase
nresult=fltarr(5,num_noise_roi)
numtemp = fltarr(noise_roi_side,noise_roi_side)
print,'pick the positions for the noise roi'
;
; loop around and wait for the ROI's to get picked
;
for j=0,num_noise_roi-1 do begin
print,j
cursor,x,y,1,/device
wait,2.0
print,x/4,y/4
;
; result holds the data, 0,1=x and y, 2=mean,3=standard deviation,4=the pixel value
;
nresult(0,j) = x/4         ; save x value
nresult(1,j) = y/4         ; save y value
for k=0,noise_roi_side-1 do begin
 for i=0, noise_roi_side-1 do begin
 numtemp(i,k) = a(x/4+i,y/4+k)
 endfor
endfor
ntemp = moment(numtemp,sdev=sd_n)
print,numtemp,sd_n
nresult(2,j) = ntemp(0)    ; save mean value
nresult(3,j) = sd_n        ; save standard deviation
nresult(4,j) = a(x/4,y/4)  ; save single pixel value
sdsum = sdsum + sd_n
endfor
nresult = float(nresult)
;
; snr calculation
;
; first calculate the mean of the noise sd's.
meansd = sdsum / num_noise_roi
print, arrayname
;
;print, 'num_noise_roi = ', wid2.num_noise_roi
;print, 'sdsum = ', sdsum
;
; now make a vector with the snr's in it
for i=0,num_sig_roi-1 do begin
print, 'SNR (ROI) for ROI #',i+1, '=',sresult(2,i) / nresult(2,i)
snr(i) = sresult(2,i) / (1.31 * sdsum / num_noise_roi) ; the factor of 1.31 is because the image is magnitude calculated
print, 'SNR (sd) for ROI #',i+1,'=', snr(i)
endfor
; this is for putting the data into a file - not used at the moment
;openw,1,arrayname+'res.dat'
;printf,1,format='(30X,"air",30X,"carbogen")'
;printf,1,format='(5f9.2,5x,3f9.2)',result
;close,1
end