; this is just a test routine so I can get used to IDL's syntax. This will lead to
; developing the T1,T2 map simulator.
; DGB 3/12/03

pro t1t2Map
	nFreqEncodes = 256
	nPhaseEncodes = 256
	sizeIndex = 3 ; remember IDL starts arrays at index 0
	index5 = [4,5,6,7,8,9,10,11]	; image directories of cucumber5 images
	index7 = [4,5,6,7,8,9,10]		; image directories of cuc7 images
	cuc7TE = [.03,.05,.07,.09,.120,.150,.200]	; TE values used for cuc7 imaging (T2 weight)
	cucumber5TR = [.028,.050,.080,.150,.300,.500,.700,1.000]	; TR values for cucumber5 imaging (T1 weight)
	nIndex5 = size(index5)			; get size of index5 array
	nIndex7 = size(index7)			; get size of index7 array
	nCuc7Images = nIndex7(sizeIndex); # of images in cuc7 directory
	nCucumber5Images = nIndex5(sizeIndex)	; # of images in cucumber5 images
	pixels5 = fltarr(nIndex5(sizeIndex))	; set up pixels5 array dynamically
	pixels7 = fltarr(nIndex7(sizeIndex))	; set up pixels7 array dynamically
	t1image = intarr(256,256)				; images are in integer format 16-bit signed
	directory5 = 'f:/bruker/cucumber5.iK1/'
	directory7 = 'f:/bruker/cuc7.iL1/'
	close, 1	; I don't know why this needs to be here but it keeps IDL from telling me that '1 is already open'
	for freqPixelNum = 0,15 do begin
		for phasePixelNum = 0,15	do begin
			for loopNum = 0,ncuc7Images - 1 do begin
				filename = directory7+strtrim(string(index7(loopNum)),2)+'/pdata/1/2dseq' ;strtrim,2 removes leading and trailing blanks
				;print, filename
				openr, 1, filename, /SWAP_ENDIAN
				readu, 1, t1image	; read unformatted binary data into variable image from opened file
				pixels7[loopNum] = t1image[128,128]

			close, 1
			endfor

		endfor
	endfor
	plot, pixels7
end


