; this routine reads the raw data gathered by the Bruker system and saved into the
; fif file. This will lead to the development of the T1,T2 map simulator.
; DGB 3/14/03

pro t1t2MapRaw
	sizeIndex = 3	;the number of elements in an array is returned by 'size' as the 4th element
	dirIndex = [4,5,6,7,8,9,10]		; image directories
	temp = size(dirIndex)	;
	n = temp(sizeIndex)		; get number of elements in dirIndex array
	directory = ''
	READ, directory, PROMPT='Enter the parent directory under which your raw data is stored: '
	directory = directory+'/'
	close, /ALL

	for loopNum = 0,n - 1 do begin
		scanNumString = strtrim(string(dirIndex(loopNum)),2) ;strtrim,2 removes leading+trailing blanks
		matrixSize = FindMatrixSize(directory, scanNumString) ; get size of image
		nImages = FindNumberImages(directory, scanNumString)  ; # of images per scan
		dcOffset = FindDCOffset(directory, scanNumString)	  ; DC offset per image
		mapOffset = FindRecoMapOffset(directory, scanNumString)
		mapSlope = FindRecoMapSlope(directory, scanNumString)
		processedRawData = ProcessRaw(directory, scanNumString, matrixSize, nImages, dcOffset)
	endfor
end