; linMap
; routine to map T1 or T2 values using IDL's linear fit
; procedure (linfit)
;
pro TestLinMap2,images,nFreq,nPhase,noise,nImages,TE

	logIntensities = alog(images) ; nImages x nFreq x nPhase array
	noiseFloor = indgen(nImages)
	noiseFloor[*] = noise
	testImage = images(0,*,*)
	fitChoice = ''
	fitAnother = ''
	fitChoiceMade = 0	; allow multiple choices if first is erroneous, i.e., NOT y or n
	fitAnotherChoiceMade = 0 ; allow multiple choices when choosing to do another voxel fit
	continueFit = 1		; user sets to 0 when he/she is done fitting individual voxels (for map debugging).

	read,fitChoice,prompt = 'Do you want to look at the linear fit for a particular voxel? [y/n]'

	while fitChoiceMade EQ 0 do begin
		case fitChoice of
			'n': fitChoiceMade = 1
			'y': BEGIN
				fitChoiceMade = 1
				print, '********************************************************'
				print, 'Left click on voxel in image to fit, Right click to exit'
				print, '********************************************************'
				tvscl, images(0,*,*)
				cursor, columnFit, rowFit, /DEVICE 	; use /DEVICE to return column # and row #
				while (!MOUSE.button NE 4) do begin ; while cursor routine hasn't detected a right mouse click
					model = linfit(TE,logIntensities[*,columnFit,rowFit])
					t2 = (-1)/model[1]
					m0 = exp(model[0])
					plot,TE,logIntensities[*,columnFit,rowFit],TITLE = 'TE vs Ln(Signal)', XTITLE = 'TE (ms)', YTITLE = 'Ln(Signal)'
					print, 'T2 = '
					print,t2
					print, 'M0 = '
					print, m0
					print, '********************************************************'
					print, 'Left click on voxel in image to fit, Right click to exit'
					print, '********************************************************'
					tvscl, images(0,*,*)
					cursor, columnFit, rowFit, /DEVICE 	; use /DEVICE to return column # and row #
				endwhile
			   END ; end 'y' case
 			else: read,fitChoice,prompt = 'Bad Entry, try again! [y/n]'
		endcase
	endwhile

end
