; T1 and T2 simulator
; generate images based on selected TR and TE values and
; calculated T1,T2 and M0 maps
;
; Mz(t) = M0(1-e^(-TR/T1))e^(-TE/T2)
pro t1t2Sim
	TE = .010 	; seconds
	TR = .400		; seconds
	nFreq = 256
	nPhase = 256
	rotate180 = 2
	t1Map = fltarr(nFreq,nPhase)
	t2Map = fltarr(nFreq,nPhase)
	m0Map = fltarr(nFreq,nPhase)
	image = fltarr(nFreq,nPhase)
	noiseFactor = 1.0
	outLyerFactor = 5.0
	minOutLyers = 10000

	; Get T1 map of Matt's Brain
	t1Map = T1MapDicom(noiseFactor)
	; Get T2 map (of Matt's Brain)
	t2MapStruct = T2MapDicom(noiseFactor)
	t2Map = t2MapStruct.t2Map
;	m0Map = t2MapStruct.m0Map
	m0Map = rotate(read_dicom('f:/images/brain/mattO/imageTR3000TE10'),rotate180)	; read DICOM formatted

	for is = 0,nFreq - 1 do begin
		for js = 0,nPhase - 1 do begin
			image(js,is) = m0Map(js,is)*(1-exp(-TR/t1Map(js,is)))*exp(-TE/t2Map(js,is))
		endfor
	endfor

	RemoveOutLyers, image,nFreq,nPhase,outLyerFactor,minOutLyers
	live_image, image, TITLE='Calculated Image'

end


