;;; Kernel Blur
;   DGB 6/21/04
; Filter or blur the image with a weighted kernel such as
; 1 4  1
; 4 12 4
; 1 4  1

pro KernelBlur, images

	nImages = 1
	temp = size(images)

	nPhase = 256
	nFreq = 256
	;if (temp(0) EQ 2) then begin

	;	nPhase = N_ELEMENTS(images(1,*))
	;	nFreq = N_ELEMENTS(images(*,1))
	;	nImages = 1

	;endif else begin (temp(0) EQ 3)
		;nPhase = N_ELEMENTS(images(0,1,*))
	;	nFreq = N_ELEMENTS(images(0,*,1))
	;	nImages = temp(1)
	;endelse

	; see The Image Processing Handbook, 2nd ed. page 157-158
	weightedKernel = [[1,4,1], [4,12,4], [1,4,1]]

	; the kernel is 3x3 so don't allow the top and bottom rows
	; of the kernel to extend beyond the image boundaries
	for imageNum = 0, nImages - 1 do begin

		; traverse the image and multiply the kernel
		for row = 1,nPhase-2 do begin
			for col = 1,nFreq-2 do begin
				; get 3x3 pixels from image to mult. by weighted kernel
				;print, row
				;print, col

				;pixelKernel = images(imageNum,col-1:col+1,row-1:row+1)
				pixelKernel = images(col-1:col+1,row-1:row+1)
				; now multiply the two arrays, '*' does element-by-element mult.
				pixelReplacement = total((pixelKernel*weightedKernel)) / total(weightedKernel)
				;print, pixelReplacement
				; now replace the center pixel with the updated weighted average
				;images(imageNum,col,row) = pixelReplacement
				images(col,row) = pixelReplacement

			endfor
		endfor
 	endfor

end


