;
; IDL Event Callback Procedures
; compound_eventcb
;
; Generated on:	12/30/103 16:53.17
;
;-----------------------------------------------------------------
; Post Create Widget Procedure.
; Argument:
;   wWidget - ID number of specific widget.
;
;   Any keywords passed into the generated widget creation procedure
;       are passed into this procudure.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro AddCW, wWidget, _EXTRA=_VWBExtra_
	idslide = cw_fslider(wWidget, /suppress_value)
end
;-----------------------------------------------------------------
; Handle Event Callback Function.
; Argument:
;   Event structure:
;
;   {WIDGET_<type>, ID:0L, TOP:0L, HANDLER:0L,...}
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;
;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
function HandleEvent, Event
   ; Fslider event structure is an anonymous structure, so
   ; the following will return "" if it is from fslider.

   if(Tag_Names(Event, /structure_name) eq "")then begin

     ; Get the id of the label widget using its name.
     id = widget_info(Event.top, find_by_uname='label')

     ; Set the value of the label, to the value in the slider.
     widget_control, id, set_value= String(Event.value, format='(f5.2)')
     return,0
     ; Halt event processing here.

   end

     return, Event ; By Default, return the event.

end
;
; Empty stub procedure used for autoloading.
;
pro compound_eventcb
end
