;
; IDL Event Callback Procedures
; exampleGUI_eventcb
;
; Generated on:	06/17/2004 09:32.54
;
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro OpenFile, Event
	; If there is a file, draw it to the draw widget.

	rotate180 = 2
	sFile = DIALOG_PICKFILE(FILTER='*.dcm')
	IF(sFile NE "")THEN BEGIN
	   ; Find the draw widget, which is named Draw.
	   wDraw = WIDGET_INFO(Event.top, FIND_BY_UNAME='Draw');
	   ; Make sure something was found.
	   IF(wDraw GT 0)THEN BEGIN
	      	; Make the draw widget the current, active window.
	      	WIDGET_CONTROL, wDraw, GET_VALUE=idDraw
	      	WSET,idDraw
	      	; Read in the image.

	      	;im = READ_PNG(sFile, red, green, blue)
			; DAVE read in DICOM images and rotate by 180 degrees
	      	im = rotate(READ_DICOM(sFile, red, green, blue),rotate180)

	      	; If TrueColor image, quantize image to pseudo-color:
       		IF (SIZE(im, /N_DIM) EQ 3) THEN $
	   			im = COLOR_QUAN(im, 1, red, green, blue)

	      	; Size the image to fill the draw area.
	      	im = CONGRID(im, !D.X_SIZE, !D.Y_SIZE)
	      	; Handle TrueColor displays:
	      	DEVICE, DECOMPOSED=0

	      	; Load color table, if one exists:
	      	IF (N_ELEMENTS(red) GT 0) THEN TVLCT, red, green, blue

	      	; Display the image.
	      	TV, im
	      	; Save the image in the uvalue of the top-level base.
	      	WIDGET_CONTROL, Event.top, SET_UVALUE=im, /NO_COPY

   		ENDIF
	ENDIF
end

;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro OnExit, Event
	WIDGET_CONTROL, Event.top, /DESTROY
end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro OnColor, Event

	XLOADCT, /BLOCK

	; Find the draw widget, which is named Draw:
	wDraw = WIDGET_INFO(Event.top, FIND_BY_UNAME='Draw')

	IF(wDraw GT 0) THEN BEGIN
	   ; Make the draw widget the current, active window:
	   WIDGET_CONTROL, wDraw, GET_VALUE=idDraw
	   WSET, idDraw
	   WIDGET_CONTROL,Event.top, GET_UVALUE=im, /NO_COPY
	   ; Make sure the image exists:
	   IF (N_ELEMENTS(im) NE 0) THEN BEGIN
	   		; Display the image:
	      	TV, im
	      	; Save the image in the uvalue of the top-level base:

      		WIDGET_CONTROL, Event.top, SET_UVALUE=im, /NO_COPY
	   ENDIF
	ENDIF
end

;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro DoSmooth, Event
	; Get the image stored in the uvalue of the top-level-base.

	WIDGET_CONTROL, Event.top, GET_UVALUE=image, /NO_COPY
	; Make sure the image exists.
	IF(N_ELEMENTS(image) GT 0)THEN BEGIN
	   ; Smooth the image.
	   image = SMOOTH(image, 5)

	   ; Display the smoothed image.
	   TV, image
	   ; Place the new image in the uvalue of the button widget.
	   WIDGET_CONTROL, Event.top, SET_UVALUE=image, /NO_COPY
	ENDIF
end
;
; Empty stub procedure used for autoloading.
;
pro exampleGUI_eventcb
end
