;
; IDL Event Callback Procedures
; example_eventcb
;
; Generated on:	12/30/03 14:57.08
;
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro OpenFile, Event
	; If there is a file, draw it to the draw widget.
   sFile = Dialog_Pickfile(filter="*.dcm")
   if(sFile ne "") then begin

     ; Find the draw widget, which is named Draw.
     wDraw = Widget_Info(Event.top, find_by_uname="Draw");
     ; Make sure something was found.
     if(wDraw gt 0) then begin
       ; Make the draw widget the current, active window.
       widget_control, wDraw, get_value=idDraw
       wset,idDraw

       ; Read in the image.
	   im = rotate(read_dicom(sFile),2)		; read DICOM formatted image
       ;read_gif,sFile, im
       ; Size the image to fill the draw area.
       im = congrid(im, !d.x_size, !d.y_size)
       ; Display the image.
       tv, im
       ; Save the image in the uvalue of the top-level base.
       widget_control, Event.top, set_uvalue=im, /no_copy
     endif
   endif

end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro OnExit, Event
	widget_control, Event.top, /destroy
end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro OnColor, Event
	xloadct
end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro DoSmooth, Event
	; Get the image stored in the uvalue of the top-level-base.
   widget_control, Event.top, get_uvalue=image, /no_copy
   ; Make sure the image exists.
   if(n_elements(image) gt 0)then begin

     ; Smooth the image.
     image = smooth(image, 5)
     ; Display the smoothed image.
     tv, image
     ; Place the new image in the uvalue of the button widget.
     widget_control, Event.top, set_uvalue=image, /no_copy
   endif

end
;
; Empty stub procedure used for autoloading.
;
pro example_eventcb
end
