
pro widget3_event, ev
	; need to save the value of the seed variable for the random number
	; generator between calls to the event-handling routine. We do this
	; using a COMMON block
	common wid3, seed

	; retrieve the widget ID of the draw widget and make it the current
	; IDL graphics window:
	widget_control, ev.top, GET_UVALUE=drawID
	wset, drawID

	; check the type of event structure returned. If it's a timer event,
	; change the color table index to a random number between 0 and 40.
	if(tag_names(ev, /STRUCTURE_NAME) EQ 'WIDGET_TIMER') $
		then begin
		table = fix(randomu(seed)*41) ; pick a random number
		loadct, table				  ; load the color table
		widget_control, ev.id, timer = 3.0	; reset the timer
	endif

	; if the event is a droplist event, change the type of plot
	; displayed in the draw widget. Note the use of the index field
	; of events returned from the droplist widget to determine the
	; value selected.
	if (tag_names(ev, /STRUCTURE_NAME) EQ 'WIDGET_DROPLIST') $
		then begin
		case ev.index of
			0: plot, dist(150)
			1: surface, dist(150)
			2: shade_surf, dist(150)
			3: widget_control, ev.top, /DESTROY
		endcase
	endif

end

pro widget3
	; create a base widget containing a draw widget and a droplist menu.
	select = ['Plot', 'Surface', 'Shaded Surface', 'Done']
	base = widget_base(/COLUMN)
	draw = widget_draw(base, xsize = 150, ysize = 150)
	dlist = widget_droplist(base, VALUE=select)
	; realize the widget hierarchy, then retrieve the value of the draw
	; widget and store it in the user value of the base widget. (Note
	; that we are using Direct graphics for the draw widget, so the value
	; is an IDL graphics window ID.) Finally, set the timer value of the
	; draw widget.
	widget_control, base, /REALIZE
	widget_control, draw, GET_VALUE=drawID
	widget_control, base, SET_UVALUE=drawID
	widget_control, draw, TIMER=0.0

	; set the droplist to display, "Shaded Surface" and place
	; a shaded surface in the draw widget:
	widget_control, dlist, set_droplist_select=2
	wset, drawID
	print, drawID
	shade_surf, dist(150)
	; register the widget with the xmanager
	xmanager, 'widget3', base

end